routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Route::get('/ws/districts', 'HomeController@districts')->name('home.districts');
Route::get('/ws/neighborhoods', 'HomeController@neighborhoods')->name('home.neighborhoods');

Route::group([
    'namespace' => 'Manager',
    'as' => 'manager.',
    'prefix' => 'manager',
    'middleware' => ['auth', 'auth.as.manager'],
], function () {
    Route::resource('farmers', 'FarmerController');
    Route::get('/farms/create-for-farmer/{farmer_id}', 'FarmController@createForOneFarmer')->name('farms.farmer.create');
    Route::post('/farms/store-for-farmer/{farmer_id}', 'FarmController@storeForOneFarmer')->name('farms.farmer.store');
    Route::get('/farm-maps/add/{id}', 'FarmMapController@add')->name('farm-maps.add');
    Route::post('/farm-maps/store/{id}', 'FarmMapController@store')->name('farm-maps.store');
    Route::resource('users', 'UserController');

});

Route::group([
    'namespace' => 'Agent',
    'as' => 'agent.',
    'prefix' => 'agent',
    'middleware' => ['auth', 'auth.as.agent'],
], function () {
    Route::resource('farmers', 'FarmerController');
    Route::get('/farms/create-for-farmer/{farmer_id}', 'FarmController@createForOneFarmer')->name('farms.farmer.create');
    Route::post('/farms/store-for-farmer/{farmer_id}', 'FarmController@storeForOneFarmer')->name('farms.farmer.store');
    Route::get('/farm-maps/add/{id}', 'FarmMapController@add')->name('farm-maps.add');
    Route::post('/farm-maps/store/{id}', 'FarmMapController@store')->name('farm-maps.store');

});

Route::group([
    'namespace' => 'Farmer',
    'as' => 'farmer.',
    'prefix' => 'farmer',
    'middleware' => ['auth', 'auth.as.farmer'],
], function () {
    Route::resource('farmers', 'FarmerController');
    Route::get('/farms/create-for-farmer/{farmer_id}', 'FarmController@createForOneFarmer')->name('farms.farmer.create');
    Route::post('/farms/store-for-farmer/{farmer_id}', 'FarmController@storeForOneFarmer')->name('farms.farmer.store');
    Route::get('/farm-maps/add/{id}', 'FarmMapController@add')->name('farm-maps.add');
    Route::post('/farm-maps/store/{id}', 'FarmMapController@store')->name('farm-maps.store');

});


Route::get('/', 'HomeController@index')->name('home')->middleware('auth');
Route::get('/search', 'HomeController@search')->name('search')->middleware('auth');






Auth::routes();

app/Models/Farmer.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Farmer extends Model
{
    protected $fillable = [
        'first_name', 
        'last_name', 
        'detail', 
        'photo_path',
        'town_id',
        'district_id',
        'neighborhood_id',
        'household_code',
        'responder_code',
        'household_head_name',
        'phone',
        'locality_native',
        'household_type',
        'rice_farmer_number',
        'user_id',
    ];

    public function photo()
    {
        return ($this->photo_path) ? 'storage/' . substr($this->photo_path, 7, strlen($this->photo_path)) : null;
    }

    public function farms()
    {
        return $this->hasMany('App\Models\Farm');
    }

    public function town()
    {
        return $this->belongsTo('App\Models\Town');
    }

    public function district()
    {
        return $this->belongsTo('App\Models\District');
    }

    public function neighborhood()
    {
        return $this->belongsTo('App\Models\Neighborhood');
    }

}

app/Http/Controllers/Agent/FarmController.php
<?php

namespace App\Http\Controllers\Agent;

use App\Models\Farm;
use App\Models\Farmer;
use App\Models\FarmMap;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Auth;
use App\Http\Controllers\Controller;


class FarmController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
    }

    public function createForOneFarmer($farmer_id)
    {
        $farmer = Farmer::findOrFail($farmer_id);
        $farm = new Farm;
        return view('agent.farm.create', compact('farmer', 'farm'));
    }

    public function storeForOneFarmer(Request $request, $farmer_id)
    {
        $farmer = Farmer::findOrFail($farmer_id);

        $now = Carbon::now();
        $data = $request->all();
        $data['farmer_id'] = $farmer->id;
        $farm = new Farm($data);

        if ($farm->save()) {
            if ($request->file('farm_map')) {
                $farmMap = new FarmMap([
                    'path' => $request->file('farm_map')->storeAs(
                        'public/farms', $now->timestamp . '_' . $farmer->id . '.' . $request->file('farm_map')->extension()
                    ),
                    'farm_id' => $farm->id,
                    'user_id' => Auth::user()->id,
                    'comment' => ''
                ]);
                $farmMap->save();
            }
            $request->session()->flash('success', 'Champ ajoute avec succes.');
            return redirect()->route('agent.farmers.show', ['farmer' => $farmer]);
        }
        $request->session()->flash('error', 'Echec d\'ajout du champ.');
        return redirect()->route('agent.farmers.show', ['farmer' => $farmer]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Farm  $farm
     * @return \Illuminate\Http\Response
     */
    public function show(Farm $farm)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Farm  $farm
     * @return \Illuminate\Http\Response
     */
    public function edit(Farm $farm)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Farm  $farm
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Farm $farm)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Farm  $farm
     * @return \Illuminate\Http\Response
     */
    public function destroy(Farm $farm)
    {
        //
    }
}

app/Http/Controllers/Agent/FarmMapController.php
<?php

namespace App\Http\Controllers\Agent;

use App\Models\Farm;
use App\Models\FarmMap;
use Auth;
use Carbon\Carbon;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;


class FarmMapController extends Controller
{
    public function add($id)
    {
        $farm = Farm::findOrFail($id);
        $farmMap = new FarmMap;
        return view('agent.farm_map.add', compact('farm', 'farmMap'));
    }

    public function store(Request $request, $id)
    {
        $farm = Farm::findOrFail($id);
        $now = Carbon::now();
        $data = $request->all();
        $data['farm_id'] = $farm->id;
        $data['user_id'] = Auth::user()->id;
        $farmMap = new FarmMap([
            'path' => $request->file('farm_map')->storeAs(
                'public/farms', $now->timestamp . '_' . $farm->farmer->id . '.' . $request->file('farm_map')->extension()
            ),
            'farm_id' => $farm->id,
            'user_id' => Auth::user()->id,
            'comment' => $request->input('comment'),

        ]);

        if ($farmMap->save()) {
            $request->session()->flash('success', 'Carte ajoutee avec succes.');
            return redirect()->route('agent.farmers.show', ['farmer' => $farm->farmer]);
        } else {
            $request->session()->flash('error', 'Carte non ajoutee.');
            return redirect()->route('agent.farmers.show', ['farmer' => $farm->farmer]);
        }

    }
}

app/Http/Controllers/Agent/FarmerController.php
<?php

namespace App\Http\Controllers\Agent;

use App\Models\Farmer;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Town;
use Carbon\Carbon;
use Auth;

class FarmerController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $farmers = Farmer::latest()->get();
        $towns = Town::orderBy('name', 'asc')->pluck('name', 'id');
        return view('agent.farmer.index', compact('farmers', 'towns'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $farmer = new Farmer;
        $towns = Town::orderBy('name', 'asc')->pluck('name', 'id');
        return view('agent.farmer.create', compact('farmer', 'towns'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $now = Carbon::now();
        $data = $request->all();

        $data['locality_native'] = ($request->input('locality_native'))? true : false;
        $data['user_id'] = Auth::user()->id;

        if ($request->file('photo')) {
            $data['photo_path'] = $request->file('photo')->storeAs(
                'public/farmers', $now->timestamp . '.' . $request->file('photo')->extension()
            );
        }

        $farmer = new Farmer($data);
        if ($farmer->save()) {
            $request->session()->flash('success', 'Producteur ajoute avec succes.');
            return redirect()->route('agent.farmers.index');
        } else {
            $request->session()->flash('error', 'Echec d\'ajout du producteur.');
            return back();
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $farmer = Farmer::findOrFail($id);
        return view('agent.farmer.show', compact('farmer'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $farmer = Farmer::findOrFail($id);
        $towns = Town::orderBy('name', 'asc')->pluck('name', 'id');
        return view('agent.farmer.edit', compact('farmer', 'towns'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $farmer = Farmer::findOrFail($id);
        $now = Carbon::now();
        
        $data = $request->all();
        $data['locality_native'] = ($request->input('locality_native')) ? true : false;

        if ($request->file('photo')) {
            $data['photo_path'] = $request->file('photo')->storeAs(
                'public/farmers', $now->timestamp . '.' . $request->file('photo')->extension()
            );
        }

        if ($farmer->update($data)) {
            $request->session()->flash('success', 'Producteur mise a jour avec succes.');
            return redirect()->route('agent.farmers.index');
        } else {
            $request->session()->flash('error', 'Echec de mise a jour du producteur.');
            return back();
        }

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Request $request, $id)
    {
        $farmer = Farmer::findOrFail($id);
        if ($farmer->delete()) {
            $request->session()->flash('success', 'Producteur supprime');
            return back();
        } else {
            $request->session()->flash('error', 'Producteur non supprime');
            return back();
        }

    }
}

app/Http/Controllers/Farmer/FarmController.php
<?php

namespace App\Http\Controllers\Farmer;

use App\Models\Farm;
use App\Models\Farmer;
use App\Models\FarmMap;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Auth;
use App\Http\Controllers\Controller;


class FarmController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
    }

    public function createForOneFarmer($farmer_id)
    {
        $farmer = Farmer::findOrFail($farmer_id);
        $farm = new Farm;
        return view('farmer.farm.create', compact('farmer', 'farm'));
    }

    public function storeForOneFarmer(Request $request, $farmer_id)
    {
        $farmer = Farmer::findOrFail($farmer_id);

        $now = Carbon::now();
        $data = $request->all();
        $data['farmer_id'] = $farmer->id;
        $farm = new Farm($data);

        if ($farm->save()) {
            if ($request->file('farm_map')) {
                $farmMap = new FarmMap([
                    'path' => $request->file('farm_map')->storeAs(
                        'public/farms', $now->timestamp . '_' . $farmer->id . '.' . $request->file('farm_map')->extension()
                    ),
                    'farm_id' => $farm->id,
                    'user_id' => Auth::user()->id,
                    'comment' => ''
                ]);
                $farmMap->save();
            }
            $request->session()->flash('success', 'Champ ajoute avec succes.');
            return redirect()->route('farmer.farmers.show', ['farmer' => $farmer]);
        }
        $request->session()->flash('error', 'Echec d\'ajout du champ.');
        return redirect()->route('farmer.farmers.show', ['farmer' => $farmer]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Farm  $farm
     * @return \Illuminate\Http\Response
     */
    public function show(Farm $farm)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Farm  $farm
     * @return \Illuminate\Http\Response
     */
    public function edit(Farm $farm)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Farm  $farm
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Farm $farm)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Farm  $farm
     * @return \Illuminate\Http\Response
     */
    public function destroy(Farm $farm)
    {
        //
    }
}

app/Http/Controllers/Farmer/FarmMapController.php
<?php

namespace App\Http\Controllers\Farmer;

use App\Models\Farm;
use App\Models\FarmMap;
use Auth;
use Carbon\Carbon;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;


class FarmMapController extends Controller
{
    public function add($id)
    {
        $farm = Farm::findOrFail($id);
        $farmMap = new FarmMap;
        return view('farmer.farm_map.add', compact('farm', 'farmMap'));
    }

    public function store(Request $request, $id)
    {
        $farm = Farm::findOrFail($id);
        $now = Carbon::now();
        $data = $request->all();
        $data['farm_id'] = $farm->id;
        $data['user_id'] = Auth::user()->id;
        $farmMap = new FarmMap([
            'path' => $request->file('farm_map')->storeAs(
                'public/farms', $now->timestamp . '_' . $farm->farmer->id . '.' . $request->file('farm_map')->extension()
            ),
            'farm_id' => $farm->id,
            'user_id' => Auth::user()->id,
            'comment' => $request->input('comment'),

        ]);

        if ($farmMap->save()) {
            $request->session()->flash('success', 'Carte ajoutee avec succes.');
            return redirect()->route('farmer.farmers.show', ['farmer' => $farm->farmer]);
        } else {
            $request->session()->flash('error', 'Carte non ajoutee.');
            return redirect()->route('farmer.farmers.show', ['farmer' => $farm->farmer]);
        }

    }
}

resources/views/agent/farmer/create.blade.php
@extends('layouts.app') 

@section('content')
     @include('agent.farmer.shared.form', ['url' => ['agent.farmers.store', $farmer], 'method' => 'post'])
@endsection

resources/views/agent/farmer/edit.blade.php
@extends('layouts.app')

@section('content')

<div class="card">
  <div class="card-header">
    <h4 class="card-title">Modifier ce producteur</h4>
  </div>
  <div class="card-body">
    @include('agent.farmer.shared.edit', ['url' => ['agent.farmers.update', $farmer], 'method' => 'put'])
  </div>
</div>
@endsection

resources/views/agent/farmer/index.blade.php
@extends('layouts.app') @section('content')
@include('shared.search')
<div class="row">
    <div class="col">
        <h4>Liste des producteurs</h4>
    </div>
    <div class="col">
        <a href="{{ route('agent.farmers.create') }}" class="btn btn-primary" style="float: right;">
            <i class="fas fa-plus"></i> Ajouter un producteur</a>
    </div>
</div>
<br>
<div class="row">
    <div class="col-12">
        <ul class="list-group">
            @foreach($farmers as $farmer)
            <li href="#" class="list-group-item list-group-item-action flex-column align-items-start">
                <div class="row">
                    <div style="width: 60px; height: 60px; float: left; margin-right: 15px">
                        <img src="{{ asset($farmer->photo()) }}" alt="" class="img-thumbnail" style="max-height: 60px;">
                    </div>
                    <div style="float: right; width: calc(100% - 85px)">
                        <div class="d-flex w-100 justify-content-between">
                            <h5 class="mb-1">{{ $farmer->first_name }} {{ $farmer->last_name }}</h5>
                            <small>{{ $farmer->created_at }}</small>
                        </div>
                        <p class="mb-1">{{ $farmer->detail }}</p>
                        <small>{{ $farmer->town->name }}, {{ $farmer->district->name }}, {{ $farmer->neighborhood->name }}</small>
                    </div>
                </div>
                <div style="float: right">
                    <a href=" {{ route('agent.farmers.show', ['farmer' => $farmer]) }} " class="btn btn-primary btn-sm">
                        <i class="far fa-eye"></i> Consulter</a>
                    <a href="{{ route('agent.farmers.edit', ['farmer' => $farmer]) }}" class="btn btn-warning btn-sm">
                        <i class="far fa-edit"></i> Modifier</a>
                     @include('agent.farmer.shared.delete', ['url' => ['agent.farmers.destroy', $farmer], 'method' => 'delete'])
                </div>
            </li>
            @endforeach
    </div>
</div>
</div>

@endsection

resources/views/agent/farmer/show.blade.php
@extends('layouts.app') @section('content')
<h4 style="text-align: center">Presentation du producteur
    <b>{{ $farmer->first_name }} {{ $farmer->last_name }}</b>
</h4>
<br>
<div class="row">
    <div class="col-12">

        <p>
            <img src="{{ asset($farmer->photo()) }}" alt="" class="img-thumbnail" style="max-height: 250px; float: left; margin-right: 10px">
            <b>Nom:</b> {{ $farmer->last_name }}
            <br>
            <b>Prenom:</b> {{ $farmer->first_name }}
            <br>
            <b>Commune:</b> {{ $farmer->town->name }}
            <br>
            <b>Arrondissement:</b> {{ $farmer->district->name }}
            <br>
            <b>Village:</b> {{ $farmer->neighborhood->name }}
            <br>
            <b>Detail:</b> {{ $farmer->detail }}
            <br>
            <b>Code du menage:</b> {{ $farmer->household_code }}
            <br>
            <b>Code du repondant:</b> {{ $farmer->responder_code }}
            <br>
            <b>Nom du chef de menage:</b> {{ $farmer->household_head_name }}
            <br>
            <b>Telephone:</b> {{ $farmer->phone }}
            <br>
            <b>Natif de la localite?</b> @if($farmer->locality_native) Oui @else Non @endif
            <br>
            <b>Type de menage:</b> {{ $farmer->household_type }}
            <br>
            <b>Nombre de riziculteurs dans le menage:</b> {{ $farmer->rice_farmer_number }}
        </p>
    </div>
    <div class="">

    </div>
</div>
<br>
<p class="text-secondary">Les champs de
    <b>{{ $farmer->first_name }} {{ $farmer->last_name }}</b>
</p>
<p>
    <a href="{{ route('agent.farms.farmer.create', ['farmer_id' => $farmer->id]) }}" class="btn btn-outline-danger">
        <i class="fas fa-plus"></i> Ajouter un champ</a>
</p>
@if(count($farmer->farms) > 0)
<div class="row">
    @foreach($farmer->farms as $farm)
    <div class="col-sm-12 col-md-4" style="margin-bottom: 10px">
        <div class="card">
            @if(count($farm->farmMaps) > 0)
            <img style="height: 200px;" class="card-img-top" src="{{ asset($farm->farmMaps[0]->map()) }}"> @endif
            <div class="card-body">
                <h5 class="card-title">Champ de: {{ $farm->cultivation_practiced }}</h5>
                <p class="card-text">{{ $farm->area }} hectares</p>
                <a data-toggle="modal" data-target="#farm-{{$farm->id}}-modal" href="#" class="btn btn-primary">
                    <i class="fa fa-eye"></i> Consulter</a>
                <a href="{{ route('manager.farm-maps.add', ['id' => $farm->id]) }}" class="btn btn-dark">
                    <i class="fa fa-map"></i> Ajouter une carte</a>
                <div class="modal fade" id="farm-{{$farm->id}}-modal" tabindex="-1" role="dialog" aria-labelledby="farm-{{$farm->id}}-modalLabel" aria-hidden="true">
                    <div class="modal-dialog modal-lg" role="document">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title" id="farm-{{$farm->id}}-modalLabel">Les cartes du champ de: {{ $farm->cultivation_practiced }}</h5>
                                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <div class="modal-body">
                            <div id="carouselExampleControls" class="carousel slide" data-ride="carousel">
                                <ol class="carousel-indicators">
                                    @foreach($farm->farmMaps as $farmMap)
                                    <li data-target="#carouselExampleIndicators" data-slide-to="{{ $loop->index }}" class="@if($loop->first) active @endif"></li>
                                    @endforeach
                                </ol>
                                <div class="carousel-inner">
                                    @foreach($farm->farmMaps as $farmMap)
                                    <div class="carousel-item @if ($loop->first) active @endif">
                                        <img style="height: 400px;" class="d-block w-100" src="{{ asset($farmMap->map()) }}">
                                        <div class="carousel-caption d-none d-md-block">
                                            <div style="background: rgba(0,0,0,0.5); color: white; border-radius: 5px">
                                                <p>
                                                    @if($farmMap->comment && $farmMap->comment != '')
                                                     {{ $farmMap->comment }} <br>
                                                    @endif
                                                    {{ $farmMap->created_at }}
                                                </p>
                                            </div>
                                        </div>
                                    </div>
                                    @endforeach
                                </div>
                                <a class="carousel-control-prev" href="#carouselExampleControls" role="button" data-slide="prev">
                                    <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                                    <span class="sr-only">Previous</span>
                                </a>
                                <a class="carousel-control-next" href="#carouselExampleControls" role="button" data-slide="next">
                                    <span class="carousel-control-next-icon" aria-hidden="true"></span>
                                    <span class="sr-only">Next</span>
                                </a>
                            </div>
                            </div>
                            <div class="modal-footer">
                                <button type="button" class="btn btn-secondary" data-dismiss="modal">Fermer</button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    @endforeach
</div>
@else
<p>Aucun champ enregistrer pour ce producteur.</p>
@endif @endsection